//  ======================================================================== //
//                                                                           //
//    File      : DirContent.cpp                                             //
//    Purpose   :                                                            //
//    Time-stamp: <Mon Jan/13/2003 10:19 MET Coder@ReallySoft.de>            //
//                                                                           //
//    (C) April 2002 by Ralf Westram                                         //
//                                                                           //
//    Permission to use, copy, modify, distribute and sell this software     //
//    and its documentation for any purpose is hereby granted without fee,   //
//    provided that the above copyright notice appear in all copies and      //
//    that both that copyright notice and this permission notice appear      //
//    in supporting documentation.                                           //
//                                                                           //
//    Ralf Westram makes no representations about the suitability of this    //
//    software for any purpose.  It is provided "as is" without express or   //
//    implied warranty.                                                      //
//                                                                           //
//  ======================================================================== //

#include "DirContent.h"
#include "Directory.h"

using namespace std;
using namespace rs;
using namespace rs::file;
using namespace playlist;

namespace playlist {
    bool show_dirs_read = false;
    bool force_sort     = false;
    bool force_shuffle = false;

    string catDirFile(const string& dir, const string& file) {
        if (dir[dir.length()-1] == '/') {
            return dir+file;
        }
        return dir+'/'+file;
    }
};

// start of implementation of class hasExtension:

// ------------------------------------------------------------------------------------------------
//      bool hasExtension::operator()(const string& /*dir*/, const struct dirent *entry) const
// ------------------------------------------------------------------------------------------------
bool hasExtension::operator()(const string& /*dir*/, const struct dirent *entry) const {
    string name      = string_lower(entry->d_name);
    size_t ext_start = name.rfind(extension);

//     cout << "name='" << name << "' extension='" << extension << "' ext_start='" << ext_start << "'\n";

    return ext_start != string::npos && (name.length()-ext_start)==extension.length();
}

// -end- of implementation of class hasExtension.

// start of implementation of class isSubDir:

// ----------------------------------------------------------------------------------------
//      bool isSubDir::operator()(const string& dir, const struct dirent *entry) const
// ----------------------------------------------------------------------------------------
bool isSubDir::operator()(const string& dir, const struct dirent *entry) const {
    struct stat st;
    string      fullname = dir + entry->d_name;
    int         result   = ::stat(fullname.c_str(), &st);
    if (result!=0) return false; // can't stat (maybe a broken link)

    string target;
    if (isLink(fullname, target)) {
        return false; // do not use linked directories
    }

    return S_ISDIR(st.st_mode);
}


// -end- of implementation of class isSubDir.

