/////////////////////////////////////////////////////////////////////////////
//
// Copyright (C) 2000
// Ralf Westram
// Time-stamp: <Sat Jan/11/2003 16:38 MET Coder@ReallySoft.de>
//
// Permission to use, copy, modify, distribute and sell this software
// and its documentation for any purpose is hereby granted without fee,
// provided that the above copyright notice appear in all copies and
// that both that copyright notice and this permission notice appear
// in supporting documentation.  Ralf Westram makes no
// representations about the suitability of this software for any
// purpose.  It is provided "as is" without express or implied warranty.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef DEFS_H
#define DEFS_H

#ifndef ERR_H
#include <Err.h>
#endif


// --------------------------------------------------------------------------------

namespace rs {
    extern bool show_debug_info;    // global debugging flag
};

// --------------------------------------------------------------------------------

#define SORT_FILE_NAME     "sort"
#define SHUFFLE_FILE_NAME  "shuffle"
#define PLAYLIST_EXTENSION ".m3u"

// --------------------------------------------------------------------------------

#ifdef __CYGWIN__
// ---------------------------------------- DOS:
# define BAD_DIR_SEPERATOR  '/'
# define GOOD_DIR_SEPERATOR '\\'
// ----------------------------------------
#else
// ---------------------------------------- otherwise LINUX (what else :))
# define BAD_DIR_SEPERATOR  '\\'
# define GOOD_DIR_SEPERATOR '/'
// ----------------------------------------
#endif

#if defined(DEBUG) && 0
#define DUMP_VAR(v) do { cout << #v << "='" << v << "'\n"; } while(0)
#else
#define DUMP_VAR(v)
#endif // DEBUG

// --------------------------------------------------------------------------------
//     inline string correctDir(string dir)
// --------------------------------------------------------------------------------
inline std::string correctDir(std::string dir) {
    if (dir.length()==0) {
        throw rs::err::Error(std::string("Illegal directory name: '")+dir+"'");
    }
    for (unsigned i=0; i<dir.length(); ++i) {
        if (dir[i]=='\\') {
            dir[i] = '/';
        }
    }

    if (dir[dir.length()-1]!='/') {
        dir += '/';
    }

    return dir;
}


#else
#error defs.h included twice
#endif // DEFS_H
