//  ======================================================================== //
//                                                                           //
//    File      : save.h                                                     //
//    Purpose   :                                                            //
//    Time-stamp: <Sun Feb/02/2003 09:59 MET Coder@ReallySoft.de>            //
//                                                                           //
//    (C) April 2002 by Ralf Westram                                         //
//                                                                           //
//    Permission to use, copy, modify, distribute and sell this software     //
//    and its documentation for any purpose is hereby granted without fee,   //
//    provided that the above copyright notice appear in all copies and      //
//    that both that copyright notice and this permission notice appear      //
//    in supporting documentation.                                           //
//                                                                           //
//    Ralf Westram makes no representations about the suitability of this    //
//    software for any purpose.  It is provided "as is" without express or   //
//    implied warranty.                                                      //
//                                                                           //
//  ======================================================================== //

#ifndef SAVE_H
#define SAVE_H

#ifndef SONG_H
#include "Song.h"
#endif


namespace playlist {

     struct savePlaylistSettings {
         std::string playlistDir;
         bool        playlistDirCreated;
         bool        ignoreWindowsLinks;
         bool        showsize;  // show number of songs in playlist name
         bool        generally_sort;
         bool        generally_shuffle;
         bool        extended_winamp_format; // save in 'extended winamp format'
         std::string normal_entry_pattern;
         std::string extended_entry_pattern;
         bool        relativePaths;
     };

    extern struct savePlaylistSettings saveSettings;
    extern std::string                 last_saved_name;

    bool savePlaylist(const std::string& name, const SongList& files, bool want_sorted, bool want_shuffled, size_t min_size);
    void rename_last_saved(const std::string& newName);

}; // end of namespace rs

#else
#error save.h included twice
#endif // SAVE_H

